#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Oct  5 19:54:38 2020

@author: WVrijmoeth
"""



import numpy as np
import matplotlib.pyplot as plt



len_l = 8
len_h = 6




tests=[]
#Base case
#tests.append([6700,'Base case positive directed waves'])
#tests.append([6700,'Base case'])
tests.append([4900,'Base case total limit is 0.5 m/s$^2$'])
tests.append([6700,'Base case total limit is 0.7 m/s$^2$'])
tests.append([4950,'Base case total limit is 1.0 m/s$^2$'])
#tests.append([8100,'Base case negative directed waves'])
#tests.append([7900,'Pos waves pos cur'])
#tests.append([7950,'Neg waves pos cur'])
#tests.append([8000,'Pos waves neg cur'])
#tests.append([8050,'Neg waves neg cur'])
# tests.append([6700,'100% floater length'])
#tests.append([8750,'Larger floater length = 37.4 m'])
#tests.append([8600,'Floater length = 30.6 m'])
#tests.append([8650,'Floater length = 27.2 m'])
# tests.append([8600,'90% floater length'])
# tests.append([8650,'80% floater length'])
#tests.append([8700,'C_inertia = 0.9'])
#
##Old base case
#tests.append([5750,'Oude base case'])
#tests.append([5850,'Oude base case met pos waves pos cur'])
#tests.append([5900,'Oude base case met pos waves neg cur'])
#tests.append([5950,'Oude base case met neg waves pos cur'])
#tests.append([6000,'Oude base case met neg waves neg cur'])
#tests.append([7600,'Situati on without turbines']) #The turbines zorgen voor heel veel forcing en daarom heel erg veel van de bewegingen....

#Heave plates
#tests.append([6300,'Heave plate full span plate'])
#tests.append([6300,'Heave plate test design'])
#tests.append([6950,'Heave plate full span (smaller added mass)'])
#tests.append([6950,'Heave plate alternative'])
#tests.append([8200,'Heave plate full span (medium added mass)'])
#tests.append([8400,'Heave plate 68 m doesn't work --> no results'])
#tests.append([8500,'Heave plate 1 x 68 m'])

#tests.append([8450,'Upper heave plates'])
#tests.append([6750,'Heave plate 70x30 m'])
#tests.append([6800,'Heave plate 50x30 m'])
#tests.append([6850,'Heave plate 30x30 m'])
#tests.append([7000,'Heave plate 98x20 m'])
#tests.append([7300,'Heave plate 3x10x35 m incl. 2nd level excl. structure mass'])
#tests.append([7350,'Heave plate 3 x lower and upper plate'])
#tests.append([7500,'Heave plate 3 x lower plate'])
#tests.append([7500,'Lower heave plates'])
#tests.append([7850,'Heave plate 3 x upper plate'])
#tests.append([])
#tests.append([])
#tests.append([])
#tests.append([])

#tests.append([7500,'Variant 1: Lower heave plates'])
#tests.append([8450,'Variant 2: Upper heave plates'])
#tests.append([8500,'Variant 3: Heave plate 1 x 68 m'])

#tests.append([7300,'Lower and upper heave plate excl. structure mass'])
#tests.append([7350,'Lower and upper heave plate incl. structure mass'])



#Sway plates
#tests.append([7050,'Sway plate 3 x 16.7 m'])
#tests.append([7700,'Sway plate 6 x 16.7 m'])
#tests.append([7800,'Sway plate 9 x 17 m'])
#tests.append([7800,'Resulting design'])
#tests.append([8800,'Resulting design (verifying the script)'])
#tests.append([7800,'Resulting design original hinge location y = 4.5 m'])
#tests.append([8850,'Resulting design improved hinge location y = 13.5 m'])
#tests.append([8150,'Sway plate 9 x 16.7 m neg waves'])
#tests.append([6200,'Sway plate 1 x 98 m'])
#tests.append([6200,'Sway plate alternative'])
#tests.append([6250,'Sway plate 1 x 98 m met neg waves'])
#tests.append([7750,'Sway plate 2 x 98 m'])
#tests.append([8300,'Sway plate 1 x 70 m'])
#tests.append([8350,'Sway plate 2 x 70 m'])
#tests.append([7550,'High sway plate 98x8'])
#tests.append([7650,'Sway plates between turbines'])
#tests.append([])
#tests.append([])
#tests.append([])


#tests.append([7050,'Variant 4: Sway plate 3 x 17 m'])
#tests.append([7700,'Variant 5: Sway plate 6 x 17 m'])
#tests.append([7800,'Variant 6: Sway plate 9 x 17 m'])
#tests.append([8300,'Variant 7: Sway plate 1 x 70 m'])
#tests.append([8350,'Variant 8: Sway plate 2 x 70 m'])
#tests.append([7650,'Variant 9: Sway plates between turbines'])




#Slosh dampers
#tests.append([6900,'Slosh damper 5%'])
#tests.append([7100,'Slosh damper 5.2 sec, 10%'])
#tests.append([7150,'Slosh damper 3.9 sec sec, 10%'])
#tests.append([8250,'Slosh damper misschien 3.9 sec, 10% smaller time step'])
#tests.append([8250,'Slosh damper m = 10% and time step = 0.015'])
#tests.append([8250,'Slosh damper alternative, m = 10%, tuned to 3.9 sec'])
#tests.append([7250,'Slosh damper 3.9 sec, 30%'])
#tests.append([7250,'Slosh damper alternative, m = 30%, tuned to 3.9 sec'])
#tests.append([])
#tests.append([])
#tests.append([])
#tests.append([])

Wave_height_probability = np.loadtxt("Wave_height_probability.csv",delimiter=',')
Wave_period_probability = np.loadtxt("Wave_period_probability.csv",delimiter=',')
Total_probability = np.loadtxt("Total_probability.csv",delimiter=',')

Wave_period=[]
Limit_acc_tot=[]
filename=[]

for i in range(len(tests)):
    First_Test_Number = tests[i][0]
    Last_Test_Number = int(First_Test_Number + len_h * len_l - 1)
    limit_acc_tot = np.loadtxt("Figures_combined_graph/limit_acc_tot_{}-{}.csv".format(f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}"), delimiter=',')
    Wave_period.append(np.loadtxt("Figures_combined_graph/Wave_period_enhanced_{}-{}.csv".format(f"{First_Test_Number:05d}",f"{Last_Test_Number:05d}"), delimiter=','))
    Limit_acc_tot.append(limit_acc_tot)
    filename.append(tests[i][0])


filename = str(filename)
plt.figure(figsize=(16.1, 9.0))
minnumber = 4
y_upper=np.array([3,3])
for i in range(len(tests)):
    plt.plot(Wave_period[i],Limit_acc_tot[i],label=tests[i][1],linestyle='--',linewidth=2)
    upper_bound = minnumber*np.ones(len(Wave_period[i]))
    plt.fill_between(Wave_period[i],Limit_acc_tot[i],upper_bound,color='red',alpha=0.1)
#    if max(Limit_acc_tot[i])<minnumber:
#        minnumber = max(Limit_acc_tot[i])
plt.plot(Wave_period_probability[:,0],Wave_height_probability,'k',label='Wave characteristics',linewidth=2)
plt.plot(Wave_period_probability[:,1],Wave_height_probability,'gray',label='Wave characteristics lower 5%',linewidth=2)
plt.plot(Wave_period_probability[:,2],Wave_height_probability,'gray',label='Wave characteristics upper 5%',linewidth=2 )
plt.fill_betweenx(Wave_height_probability,Wave_period_probability[:,1],Wave_period_probability[:,2],color='gray',alpha=0.3)
plt.xlim(0,max(Wave_period[0]))
plt.ylim(0,1.75)
plt.xlabel('Wave period (s)', fontsize=15)
plt.ylabel('Wave height (m)', fontsize=15)
plt.grid(b=True, which='major',color='lightgray')
plt.minorticks_on()
plt.grid(b=True, which='minor', color='#999999', linestyle='-', alpha=0.2)
plt.title('Regions of exceeding the total acceleration serviceability limit of 0.7 m/s$^2$',fontsize=20)
plt.legend(loc=4,fontsize=13)
plt.savefig("Figures_combined_graph/Exceedance_region_of_total_serviceability_limit_{}".format(f"{filename}"),dpi=500)


#
##Wave characteristics
#filename = str(filename)
#plt.figure(figsize=(11.5, 6))
#minnumber = 4
#y_upper=np.array([3,3])
##for i in range(len(tests)):
##    plt.plot(Wave_period[i],Limit_acc_tot[i],label=tests[i][1],linestyle='--',linewidth=2)
##    upper_bound = minnumber*np.ones(len(Wave_period[i]))
##    plt.fill_between(Wave_period[i],Limit_acc_tot[i],upper_bound,color='red',alpha=0.1)
##    if max(Limit_acc_tot[i])<minnumber:
##        minnumber = max(Limit_acc_tot[i])
#plt.plot(Wave_period_probability[:,0],Wave_height_probability,'k',label='Wave characteristics',linewidth=2)
#plt.plot(Wave_period_probability[:,1],Wave_height_probability,'gray',label='5% confidence interval',linewidth=2)
#plt.plot(Wave_period_probability[:,2],Wave_height_probability,'gray',label='5% confidence interval',linewidth=2 )
#plt.fill_betweenx(Wave_height_probability,Wave_period_probability[:,1],Wave_period_probability[:,2],color='gray',alpha=0.3)
#plt.xlim((0,9))
#plt.ylim(0,1.75)
#plt.xlabel('Wave period (s)',fontsize=13)
#plt.ylabel('Wave height (m)',fontsize=13)
#plt.grid(b=True, which='major',color='lightgray')
#plt.minorticks_on()
#plt.grid(b=True, which='minor', color='#999999', linestyle='-', alpha=0.2)
#plt.title('Most probable wave height and wave period combination at the Tidal Bridge site',fontsize=15)
#plt.legend(loc=0,fontsize=10)
#plt.savefig("Figures_combined_graph/Exceedance3_region_of_total_serviceability_limit_{}".format(f"{filename}"),dpi=500)
#
#
#
##Ugly plot with probability of exceedance
#Wave_height_probability100 = np.loadtxt("Wave_height_probability.csv",delimiter=',')
#Wave_period_probability100 = np.loadtxt("Wave_period_probability.csv",delimiter=',')
#Total_probability100 = np.loadtxt("Total_probability.csv",delimiter=',')
#
#filename = str(filename)
#fig = plt.figure(figsize=(16.1, 9.0))
#ax1 = fig.add_subplot(111)
#ax2 = ax1.twinx()
#ax2.plot(Wave_period_probability100[:,0],365*Total_probability100[:,0],'plum',label='Downtime',linewidth=2)
#minnumber = 4
#y_upper=np.array([3,3])
#for i in range(len(tests)):
#    ax1.plot(Wave_period[i],Limit_acc_tot[i],label=tests[i][1],linestyle='--',linewidth=2)
#    upper_bound = minnumber*np.ones(len(Wave_period[i]))
#    ax1.fill_between(Wave_period[i],Limit_acc_tot[i],upper_bound,color='red',alpha=0.1)
#ax1.plot(Wave_period_probability100[:,0],Wave_height_probability100,'k',label='Wave characteristics',linewidth=2)
#ax1.plot(Wave_period_probability100[:,1],Wave_height_probability100,'gray',label='Wave characteristics lower 5%',linewidth=2)
#ax1.plot(Wave_period_probability100[:,2],Wave_height_probability100,'gray',label='Wave characteristics upper 5%',linewidth=2)
#ax1.fill_betweenx(Wave_height_probability100,Wave_period_probability100[:,1],Wave_period_probability100[:,2],color='gray',alpha=0.3)
##ax2.plot(Wave_period_probability[:,1],365*Total_probability[:,1],'k',label='Total',linewidth=2)
##ax2.plot(Wave_period_probability[:,2],365*Total_probability[:,2],'k',label='Total',linewidth=2)
#plt.xlim((2.5,8.5))
#ax2.set_ylim(0,10)
#ax1.set_ylim(0,1.75)
#ax2.set_ylabel('Downtime (days)')
#ax1.set_xlabel('Wave period (s)')
#ax1.set_ylabel('Wave height (m)')
#ax1.grid(b=True, which='major',color='lightgray')
#ax1.minorticks_on()
#ax1.grid(b=True, which='minor', color='#999999', linestyle='-', alpha=0.2)
#plt.title('Regions of exceeding the serviceability limit plot and a downtime plot',fontsize=20)
#ax2.legend(loc=4,fontsize=10)
#ax1.legend(loc=7,fontsize=10)
#plt.savefig("Figures_combined_graph/Exceedance2_region_of_total_serviceability_limit_{}".format(f"{filename}"),dpi=500)
